/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.PropRole
 *  fire.pb.common.SCommon
 *  fire.pb.main.ConfigManager
 *  fire.pb.map.Role
 *  fire.pb.map.RoleManager
 *  fire.pb.mission.SAnswerInstance
 *  fire.pb.mission.SAskIntoInstance
 *  fire.pb.mission.SLineTask
 *  fire.pb.talk.MessageMgr
 *  fire.pb.team.Team
 *  fire.pb.team.TeamManager
 *  fire.pb.util.DateValidate
 *  mkdb.Executor
 *  mkdb.Lockeys
 *  mkdb.Procedure
 *  mkdb.TTable
 *  mkio.Protocol
 *  xbean.InstanceAskInfo
 *  xbean.InstanceInfoCol
 *  xbean.InstanceTaskInfo
 *  xbean.Pod
 *  xtable.Instanceaskinfos
 *  xtable.Locks
 *  xtable.Properties
 *  xtable.Roleinstancetask
 */
package fire.pb.mission.instance.line;

import fire.pb.PropRole;
import fire.pb.common.SCommon;
import fire.pb.main.ConfigManager;
import fire.pb.map.Role;
import fire.pb.map.RoleManager;
import fire.pb.mission.SAnswerInstance;
import fire.pb.mission.SAskIntoInstance;
import fire.pb.mission.SLineTask;
import fire.pb.mission.instance.line.LineInstManager;
import fire.pb.talk.MessageMgr;
import fire.pb.team.Team;
import fire.pb.team.TeamManager;
import fire.pb.util.DateValidate;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import mkdb.Executor;
import mkdb.Lockeys;
import mkdb.Procedure;
import mkdb.TTable;
import mkio.Protocol;
import xbean.InstanceAskInfo;
import xbean.InstanceInfoCol;
import xbean.InstanceTaskInfo;
import xbean.Pod;
import xtable.Instanceaskinfos;
import xtable.Locks;
import xtable.Properties;
import xtable.Roleinstancetask;

public class PReqLineTask
extends Procedure {
    private final long roleid;
    private final int lineId;

    public PReqLineTask(long roleid, int taskId) {
        this.roleid = roleid;
        this.lineId = taskId;
    }

    protected boolean process() throws Exception {
        InstanceTaskInfo afterTaskInfo;
        SLineTask taskCofig = LineInstManager.getInstance().getInstanceTask(this.lineId);
        if (taskCofig == null) {
            LineInstManager.logger.error((Object)("副本数据为空 " + this.lineId));
            return false;
        }
        PropRole pRole = new PropRole(this.roleid, true);
        if (pRole.getLevel() < taskCofig.getMinlevel()) {
            ArrayList<String> paras = new ArrayList<String>(1);
            paras.add(String.valueOf(taskCofig.getMinlevel()));
            MessageMgr.psendMsgNotifyWhileRollback((long)this.roleid, (int)160100, paras);
            return false;
        }
        final Team team = TeamManager.getTeamByRoleId((long)this.roleid);
        Role mapRole = RoleManager.getInstance().getRoleByID(this.roleid);
        if (null == mapRole) {
            LineInstManager.logger.error((Object)("角色不在场景内," + this.lineId));
            return false;
        }
        if (mapRole.getMapId() != 1615) {
            LineInstManager.logger.error((Object)("角色所在地图有问题," + this.lineId));
            return false;
        }
        long nowtime = System.currentTimeMillis();
        ArrayList<Long> allRoleIDs = new ArrayList<Long>();
        if (taskCofig.getTeamnum() > 1) {
            if (team == null) {
                ArrayList<String> paras = new ArrayList<String>(1);
                paras.add(String.valueOf(taskCofig.getTeamnum()));
                MessageMgr.psendMsgNotifyWhileRollback((long)this.roleid, (int)160101, paras);
                return false;
            }
            if (team.getTeamLeaderId() != this.roleid) {
                MessageMgr.psendMsgNotifyWhileRollback((long)this.roleid, (int)160191, null);
                return false;
            }
            allRoleIDs.addAll(team.getNormalMemberIds());
            if (!this.checkTask(team, taskCofig, allRoleIDs)) {
                LineInstManager.logger.error((Object)("队伍中有等级不足的情况," + this.lineId));
                return false;
            }
            InstanceAskInfo askInst = Instanceaskinfos.select((Long)team.getTeamId());
            if (askInst != null && nowtime - askInst.getAsktime() < 20000L) {
                MessageMgr.psendMsgNotifyWhileRollback((long)this.roleid, (int)160363, null);
                return false;
            }
        } else {
            if (team != null) {
                MessageMgr.psendMsgNotifyWhileRollback((long)this.roleid, (int)144816, null);
                return false;
            }
            allRoleIDs.add(this.roleid);
        }
        this.lock(Lockeys.get((TTable)Locks.ROLELOCK, allRoleIDs));
        InstanceInfoCol teamLeadreInfoCol = null;
        InstanceTaskInfo teamLeadreTaskInfo = null;
        long currentTime = System.currentTimeMillis();
        teamLeadreInfoCol = Roleinstancetask.get((Long)this.roleid);
        if (teamLeadreInfoCol == null) {
            teamLeadreInfoCol = Pod.newInstanceInfoCol();
            Roleinstancetask.insert((Long)this.roleid, (InstanceInfoCol)teamLeadreInfoCol);
        }
        if ((teamLeadreTaskInfo = (InstanceTaskInfo)teamLeadreInfoCol.getInstinfo().get(this.lineId)) == null) {
            teamLeadreTaskInfo = Pod.newInstanceTaskInfo();
            teamLeadreInfoCol.getInstinfo().put(this.lineId, teamLeadreTaskInfo);
        }
        int teamLeaderStep = 1;
        teamLeaderStep = !DateValidate.inTheSameDay((long)teamLeadreTaskInfo.getAccepttime(), (long)currentTime) ? 1 : LineInstManager.getStep(teamLeadreInfoCol, this.lineId);
        teamLeadreInfoCol.setLastinstanceid(this.lineId);
        if (taskCofig.afterid != 0 && ((afterTaskInfo = (InstanceTaskInfo)teamLeadreInfoCol.getInstinfo().get(taskCofig.afterid)) == null || afterTaskInfo.getState() < 2)) {
            SLineTask afterTaskCofig = LineInstManager.getInstance().getInstanceTask(taskCofig.afterid);
            if (afterTaskCofig != null) {
                ArrayList<String> para = new ArrayList<String>(2);
                para.add(afterTaskCofig.taskname);
                para.add(taskCofig.taskname);
                MessageMgr.psendMsgNotify((long)this.roleid, (int)160301, para);
            }
            return false;
        }
        if (team != null) {
            InstanceAskInfo askInfo = Instanceaskinfos.get((Long)team.getTeamId());
            if (askInfo == null) {
                askInfo = Pod.newInstanceAskInfo();
                Instanceaskinfos.insert((Long)team.getTeamId(), (InstanceAskInfo)askInfo);
            } else {
                Iterator iter = askInfo.getAnswerinfo().keySet().iterator();
                while (iter.hasNext()) {
                    Long rid = (Long)iter.next();
                    if (allRoleIDs.contains(rid)) continue;
                    iter.remove();
                }
            }
            askInfo.setAsktime(nowtime);
            boolean reset = false;
            Integer askLineId = askInfo.getInstid();
            if (askLineId == null || askLineId != this.lineId) {
                askInfo.setInstid(this.lineId);
                reset = true;
            }
            SCommon common = (SCommon)ConfigManager.getInstance().getConf(SCommon.class).get(231);
            int commonCnt = Integer.parseInt(common.getValue());
            ArrayList<Long> autoEnterRoles = new ArrayList<Long>();
            for (Long rid : allRoleIDs) {
                SAskIntoInstance askInto;
                Map lineSet;
                InstanceTaskInfo afterTaskInfo2;
                InstanceTaskInfo instanceInfo;
                InstanceInfoCol infoCol = Roleinstancetask.select((Long)rid);
                Integer ridCnt = 0;
                Integer curStep = 1;
                if (infoCol == null) {
                    infoCol = Pod.newInstanceInfoCol();
                    Roleinstancetask.insert((Long)rid, (InstanceInfoCol)infoCol);
                }
                if ((instanceInfo = (InstanceTaskInfo)infoCol.getInstinfo().get(this.lineId)) == null) {
                    instanceInfo = Pod.newInstanceTaskInfo();
                    infoCol.getInstinfo().put(this.lineId, instanceInfo);
                }
                if (taskCofig.afterid != 0 && ((afterTaskInfo2 = (InstanceTaskInfo)infoCol.getInstinfo().get(taskCofig.afterid)) == null || afterTaskInfo2.getState() < 2)) {
                    SLineTask afterTaskCofig = LineInstManager.getInstance().getInstanceTask(taskCofig.afterid);
                    if (afterTaskCofig != null) {
                        ArrayList<String> para = new ArrayList<String>(3);
                        PropRole pteamRole = new PropRole(rid.longValue(), true);
                        para.add(pteamRole.getName());
                        para.add(afterTaskCofig.taskname);
                        para.add(taskCofig.taskname);
                        for (Long mem : team.getNormalMemberIds()) {
                            MessageMgr.psendMsgNotify((long)mem, (int)160439, para);
                        }
                    }
                    return false;
                }
                short autoenter = 0;
                if (!DateValidate.inTheSameDay((long)infoCol.getAccepttime(), (long)currentTime)) {
                    ridCnt = 0;
                    curStep = 1;
                } else {
                    ridCnt = infoCol.getCounts();
                    curStep = LineInstManager.getStep(infoCol, this.lineId);
                }
                if (!reset) {
                    if (askInfo.getAnswerinfo().containsKey(rid)) {
                        if ((Integer)askInfo.getAnswerinfo().get(rid) == 1) {
                            autoenter = 1;
                        }
                    } else {
                        autoenter = 0;
                    }
                }
                if (autoenter == 0 && (lineSet = Properties.selectLineconfigmap((Long)rid)).containsKey(taskCofig.minlevel) && (autoenter = ((Integer)lineSet.get(taskCofig.minlevel)).shortValue()) > 0) {
                    autoenter = 1;
                }
                if (autoenter == 1) {
                    autoEnterRoles.add(rid);
                }
                List<Integer> steplist = LineInstManager.getUndoStep(rid, this.lineId);
                LinkedList<Integer> tsteplist = new LinkedList<Integer>();
                if (steplist != null) {
                    tsteplist.addAll(steplist);
                }
                if (ridCnt < commonCnt) {
                    if (rid.longValue() == team.getTeamLeaderId()) {
                        askInto = new SAskIntoInstance(166008, taskCofig.taskname, commonCnt - ridCnt, teamLeaderStep, teamLeaderStep, curStep.intValue(), taskCofig.stepnum, tsteplist, 1, autoenter);
                        askInfo.getAnswerinfo().put(rid, Integer.valueOf(autoenter));
                        Procedure.psendWhileCommit((long)rid, (Protocol)askInto);
                        continue;
                    }
                    askInto = new SAskIntoInstance(160210, taskCofig.taskname, commonCnt - ridCnt, teamLeaderStep, teamLeaderStep, curStep.intValue(), taskCofig.stepnum, tsteplist, 1, autoenter);
                    askInfo.getAnswerinfo().put(rid, Integer.valueOf(autoenter));
                    Procedure.psendWhileCommit((long)rid, (Protocol)askInto);
                    continue;
                }
                if (rid.longValue() == team.getTeamLeaderId()) {
                    askInto = new SAskIntoInstance(166009, taskCofig.taskname, 0, teamLeaderStep, teamLeaderStep, curStep.intValue(), taskCofig.stepnum, tsteplist, 1, autoenter);
                    askInfo.getAnswerinfo().put(rid, Integer.valueOf(autoenter));
                    Procedure.psendWhileCommit((long)rid, (Protocol)askInto);
                    continue;
                }
                askInto = new SAskIntoInstance(166007, taskCofig.taskname, 0, teamLeaderStep, teamLeaderStep, curStep.intValue(), taskCofig.stepnum, tsteplist, 1, autoenter);
                askInfo.getAnswerinfo().put(rid, Integer.valueOf(autoenter));
                Procedure.psendWhileCommit((long)rid, (Protocol)askInto);
            }
            for (Long rid : autoEnterRoles) {
                SAnswerInstance answerInst = new SAnswerInstance();
                answerInst.roleid = rid;
                answerInst.answer = 1;
                Procedure.psendWhileCommit(allRoleIDs, (Protocol)answerInst);
            }
            ScheduledFuture future = Executor.getInstance().schedule(new Runnable(){

                @Override
                public void run() {
                    new Procedure(){

                        protected boolean process() throws Exception {
                            InstanceAskInfo askInst = Instanceaskinfos.get((Long)team.getTeamId());
                            if (askInst == null) {
                                return false;
                            }
                            for (Map.Entry ret : askInst.getAnswerinfo().entrySet()) {
                                if ((Integer)ret.getValue() != 0) continue;
                                String roleName = Properties.selectRolename((Long)((Long)ret.getKey()));
                                if (roleName == null) {
                                    return false;
                                }
                                ArrayList<String> para = new ArrayList<String>(1);
                                para.add(roleName);
                                for (Long rid : team.getAllMemberIds()) {
                                    MessageMgr.psendMsgNotifyWhileCommit((long)rid, (int)160211, para);
                                }
                            }
                            return true;
                        }
                    }.submit();
                }
            }, 20L, TimeUnit.SECONDS);
            LineInstManager.askInstFuture.put(team.getTeamId(), future);
        }
        return true;
    }

    private boolean checkTask(Team team, SLineTask taskCofig, List<Long> allRoleIDs) {
        ArrayList<String> levelException = new ArrayList<String>();
        for (Long mem : allRoleIDs) {
            PropRole pRole = new PropRole(mem.longValue(), true);
            if (pRole.getLevel() >= taskCofig.getMinlevel()) continue;
            levelException.add(pRole.getName());
        }
        if (!levelException.isEmpty()) {
            StringBuffer strParam = new StringBuffer();
            int nIndex = 0;
            for (String name : levelException) {
                if (nIndex != levelException.size() - 1) {
                    strParam.append(name).append(",");
                    continue;
                }
                strParam.append(name);
            }
            ArrayList<String> paras = new ArrayList<String>();
            paras.add(strParam.toString());
            paras.add(String.valueOf(taskCofig.getMinlevel()));
            for (Long mem : allRoleIDs) {
                MessageMgr.psendMsgNotifyWhileRollback((long)mem, (int)160102, paras);
            }
            return false;
        }
        if (allRoleIDs.size() < taskCofig.getTeamnum()) {
            ArrayList<String> paras = new ArrayList<String>();
            paras.add(String.valueOf(taskCofig.getTeamnum()));
            MessageMgr.psendMsgNotifyWhileRollback((long)this.roleid, (int)160103, paras);
            return false;
        }
        return true;
    }
}

